

  double fslope();
  double fprice();
  double frcost();
  void init_param();
  void init_num();
  int read_file();
  void write_data();
  void climate();

  struct mat{ struct mat *next;
              int row;
              double val; } ;

  double    *m_darr1(int);
  double   **m_darr2(int,int);
  double  ***m_darr3(int,int,int);
  double ****m_darr4(int,int,int,int);
  int       *m_iarr1(int);
  int      **m_iarr2(int,int);
  int     ***m_iarr3(int,int,int);

  struct mat **m_marr1(int);
  struct mat ***m_marr2(int,int);

  int IR,JC,KEL,KE;
  int sint,spd1,spd2,spd3,spi1,spi2,spm1,spm2;
  double **c,*f_off_set;
  double etcon,rpyt,start_yr;
  double ***co2reg,***co2tax,**co2con,**temper,***co2tran,*prob_s,**co2emi;
  double *co2cef,**shfdsk,*reoils,**dulfel,**parele,**trnlos,
         **elcoef,***chcoef,***relaef,***co2ene,*co2sub,**nclurt,
         ***tdloss,*upplmt,*lowlmt,**deprrt,co2upp,*ect_2000,**rel_2000;
  double **trcost,**plcost,***rlcost,**co2cap,**co2cst,**refore;
  double ***egrade,**epcost,***rgrade,***rpcost,**acrdrt,*nclrct,***rgdk,**rco2cef;
  double *discnt,*dis_f,*dis_p,**dis_i1,**dis_i2,**dis_i3,**dis_inv;
  double ***demand,**scnucl,**misncl,***oilsha,***ele_min,
         **pop0,**dem_2000,*cem_2000,**oilgenplt_max,**sh_new_t;
  double ***tariff,***subsid,***royalt,***profit;
  double **trland,**trocea,**trnco2;
  double ***cexist,***gepatn,**prtrad,**currpr,**ele_2000;
  double **enepri,**elast,**enepot,***dispri,**prelas;
  double ***shdpri,***enecon_f,****slope_f,****slope_df;
  double ****d_coeff,***d_const;
  double ***sulreg,***sultax,*sulcef,**desulc,*desuld,**tsoxemi,***soxemi;

  double *n_yr,*prob_k;
  double ****rpck,***cdemak,***rdemak;
  double **damage;
  double **pop0,**gdp0,**ivs0,**kap0,**inv0,**mepm,**kap_up,**kap_low,**rkap,
    **kapk,*klelas,*enelas,**prod_a,***prod_b,**prod_c,*gdp_2000,*ivs_2000,*kap_2000;
  double **landarea,***bio_productivity,***bio_potential,**bio_share,**bio_cost;

  int N_BLKM,N_SCEM,N_PLNT,N_EPLNT,N_CPLNT,N_FUEL,N_FOS,N_REN,
      N_DEM,N_EGRADE,N_RGRADE,N_DCO2,N_REFO;
  int N_BLK,N_SCE,N_TMP;
  int LR,N_TIME,ITRANS,IINTER;
  int *n_tm,**n_sc;

  int ****jc,jc1,*jc2,**jc3;
  int ****ir,ir1,*ir2,**ir3;
  int *islack,*kslack;
  int **inc_mat;

  int ictrl1,ictrl2,ictrl3,ictrl4,ictrl5,ictrl6,ictrl7,ictrl8;
  int ictrl9,ictrl10,ictrl11;
  int JP_OIL_DI,JP_OIL_GA,JP_NGAS_C,JP_COAL_G,JP_COAL_L,
      JP_BIOM_G,JP_BIOM_L,JP_CH4_SY,JP_MEOH_S,JP_MEOH_D,JP_SHIFT,
      JP_MEOH_U,JP_W_ELEC,JP_CO2R_C,JP_CO2R_P,JP_H2_LIQ,
      JP_C4_LIQ,JP_C2_LIQ,JP_BIOM_GA,JP_BIOM_LF;

